"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _CustomForm = require("./CustomForm");
var _CustomFormFieldCheckboxes = _interopRequireDefault(require("./CustomFormFieldCheckboxes"));
var _CustomFormFieldSelect = _interopRequireDefault(require("./CustomFormFieldSelect"));
var _excluded = ["label", "fieldName", "value", "onChange", "type", "className", "name", "disabled", "isValid", "feedback", "options", "emptySelectOption", "prefix", "suffix", "placeholder", "fileSizeLimit", "hint", "multi", "noOptionMessage"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var CustomFormField = function CustomFormField(_ref, ref) {
  var _ref$label = _ref.label,
    label = _ref$label === void 0 ? null : _ref$label,
    _ref$fieldName = _ref.fieldName,
    fieldName = _ref$fieldName === void 0 ? '' : _ref$fieldName,
    value = _ref.value,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? null : _ref$onChange,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'text' : _ref$type,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? '' : _ref$className,
    _ref$name = _ref.name,
    name = _ref$name === void 0 ? '' : _ref$name,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$isValid = _ref.isValid,
    isValid = _ref$isValid === void 0 ? true : _ref$isValid,
    _ref$feedback = _ref.feedback,
    feedback = _ref$feedback === void 0 ? '' : _ref$feedback,
    _ref$options = _ref.options,
    options = _ref$options === void 0 ? null : _ref$options,
    _ref$emptySelectOptio = _ref.emptySelectOption,
    emptySelectOption = _ref$emptySelectOptio === void 0 ? false : _ref$emptySelectOptio,
    _ref$prefix = _ref.prefix,
    prefix = _ref$prefix === void 0 ? null : _ref$prefix,
    _ref$suffix = _ref.suffix,
    suffix = _ref$suffix === void 0 ? null : _ref$suffix,
    _ref$placeholder = _ref.placeholder,
    placeholder = _ref$placeholder === void 0 ? '' : _ref$placeholder,
    _ref$fileSizeLimit = _ref.fileSizeLimit,
    fileSizeLimit = _ref$fileSizeLimit === void 0 ? 2097152 : _ref$fileSizeLimit,
    _ref$hint = _ref.hint,
    hint = _ref$hint === void 0 ? '' : _ref$hint,
    _ref$multi = _ref.multi,
    multi = _ref$multi === void 0 ? false : _ref$multi,
    _ref$noOptionMessage = _ref.noOptionMessage,
    noOptionMessage = _ref$noOptionMessage === void 0 ? 'Aucun résultat' : _ref$noOptionMessage,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useFormContext = (0, _CustomForm.useFormContext)(),
    displayError = _useFormContext.displayError,
    formFields = _useFormContext.formFields,
    setFormFields = _useFormContext.setFormFields,
    setFormField = _useFormContext.setFormField;
  var formValue = fieldName != '' ? formFields[fieldName] : value;
  var handleChange = function handleChange(value) {
    if (fieldName != '' && onChange == null) setFormField(fieldName, value);else if (onChange != null) onChange(value);
  };
  var renderFileInput = function renderFileInput() {
    var fileRef = (0, _react.useRef)();
    return /*#__PURE__*/_react["default"].createElement("input", _extends({
      className: "form-control ".concat(displayError && !isValid && 'is-invalid'),
      type: "file",
      ref: fileRef,
      onChange: function onChange(_) {
        if (fileRef.current.files[0].size < fileSizeLimit) {
          handleChange(fileRef.current.files);
        } else {
          alert('Le fichier est trop volumineux');
          fileRef.current.value = '';
        }
      },
      disabled: disabled
    }, props));
  };
  var renderTextarea = function renderTextarea() {
    return /*#__PURE__*/_react["default"].createElement("textarea", _extends({
      className: "form-control ".concat(displayError && !isValid && 'is-invalid'),
      value: formValue,
      onChange: function onChange(e) {
        return handleChange(e.target.value);
      },
      disabled: disabled,
      name: name,
      placeholder: placeholder,
      ref: ref
    }, props));
  };
  var renderSelect = function renderSelect() {
    return /*#__PURE__*/_react["default"].createElement(_CustomFormFieldSelect["default"], _extends({}, props, {
      label: label,
      className: "custom-select ".concat(displayError && !isValid && 'is-invalid'),
      value: formValue,
      onChange: onChange,
      fieldName: fieldName,
      setFormField: setFormField,
      name: name,
      disabled: disabled,
      placeholder: placeholder,
      ref: ref,
      options: emptySelectOption ? [{
        value: '',
        label: ''
      }].concat(_toConsumableArray(options)) : options,
      multi: multi,
      isValid: isValid,
      noOptionMessage: noOptionMessage
    }));
  };
  var renderRadio = function renderRadio() {
    var radioName = Math.random() * 1000;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "radios-container spaced-inline ".concat(className)
    }, options.map(function (_ref2, index) {
      var radioValue = _ref2.value,
        label = _ref2.label;
      var radioId = Math.random() * 1000;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "radio spaced-inline",
        key: index
      }, /*#__PURE__*/_react["default"].createElement("input", {
        type: "radio",
        name: radioName,
        value: radioValue,
        checked: radioValue === formValue,
        id: radioId,
        onChange: function onChange(e) {
          return handleChange(e.target.value);
        },
        ref: ref
      }), /*#__PURE__*/_react["default"].createElement("label", {
        htmlFor: radioId
      }, label));
    }));
  };
  var renderInput = function renderInput() {
    return /*#__PURE__*/_react["default"].createElement("input", _extends({}, props, {
      className: "form-control ".concat(displayError && !isValid && 'is-invalid'),
      value: formValue,
      onChange: function onChange(e) {
        return handleChange(e.target.value);
      },
      type: type,
      name: name,
      disabled: disabled,
      placeholder: placeholder,
      ref: ref
    }));
  };
  var renderCheckbox = function renderCheckbox() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "form-group form-check custom-checkbox"
    }, /*#__PURE__*/_react["default"].createElement("input", _extends({}, props, {
      className: "form-check-input ".concat(displayError && !isValid && 'is-invalid'),
      checked: formValue,
      onChange: function onChange(e) {
        return handleChange(e.target.checked);
      },
      type: "checkbox",
      name: name,
      disabled: disabled,
      ref: ref
    })), /*#__PURE__*/_react["default"].createElement("label", {
      className: "form-check-label",
      htmlFor: props.id
    }, label));
  };
  var renderCheckboxes = function renderCheckboxes() {
    return /*#__PURE__*/_react["default"].createElement(_CustomFormFieldCheckboxes["default"], _extends({
      options: options,
      value: formValue,
      onChange: function onChange(val) {
        return handleChange(val);
      }
    }, props));
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "custom-form-field ".concat(className)
  }, label != null && type != 'checkbox' && /*#__PURE__*/_react["default"].createElement("label", null, typeof label === 'function' ? label() : label), /*#__PURE__*/_react["default"].createElement("div", {
    className: "input-group"
  }, prefix != null && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, typeof prefix === 'function' ? prefix() : /*#__PURE__*/_react["default"].createElement("span", {
    className: "input-group-text"
  }, prefix)), type === 'select' ? renderSelect() : type === 'textarea' ? renderTextarea() : type === 'checkbox' ? renderCheckbox() : type === 'checkboxes' ? renderCheckboxes() : type === 'file' ? renderFileInput() : type === 'radio' ? renderRadio() : renderInput(), suffix != null && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, typeof suffix === 'function' ? suffix() : /*#__PURE__*/_react["default"].createElement("span", {
    className: "input-group-text"
  }, suffix)), displayError && !isValid && feedback != '' && /*#__PURE__*/_react["default"].createElement("div", {
    className: "invalid-feedback"
  }, feedback)), hint != '' && /*#__PURE__*/_react["default"].createElement("small", null, hint));
};
var _default = exports["default"] = /*#__PURE__*/_react["default"].forwardRef(CustomFormField);