"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _lodash = _interopRequireDefault(require("lodash"));
var _react = _interopRequireWildcard(require("react"));
var _async = _interopRequireDefault(require("react-select/async"));
var _Http = _interopRequireDefault(require("../services/Http"));
var _CustomForm = require("./CustomForm");
var _reactSelectStyle = require("./react-select-style");
var _excluded = ["label", "value", "onChange", "getUrl", "format", "placeholder", "noOptionsMessage", "multi", "disabled", "isValid", "className", "filterOptions"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var CustomFormFieldAsyncSelect = function CustomFormFieldAsyncSelect(_ref) {
  var _ref$label = _ref.label,
    label = _ref$label === void 0 ? '' : _ref$label,
    value = _ref.value,
    _ref$onChange = _ref.onChange,
    _onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange,
    _ref$getUrl = _ref.getUrl,
    getUrl = _ref$getUrl === void 0 ? function (inputValue) {
      return '';
    } : _ref$getUrl,
    _ref$format = _ref.format,
    format = _ref$format === void 0 ? function (opt) {
      return {};
    } : _ref$format,
    _ref$placeholder = _ref.placeholder,
    placeholder = _ref$placeholder === void 0 ? '' : _ref$placeholder,
    _ref$noOptionsMessage = _ref.noOptionsMessage,
    _noOptionsMessage = _ref$noOptionsMessage === void 0 ? function () {
      return 'Aucun résultat';
    } : _ref$noOptionsMessage,
    _ref$multi = _ref.multi,
    multi = _ref$multi === void 0 ? false : _ref$multi,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$isValid = _ref.isValid,
    isValid = _ref$isValid === void 0 ? true : _ref$isValid,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? '' : _ref$className,
    _ref$filterOptions = _ref.filterOptions,
    filterOptions = _ref$filterOptions === void 0 ? function (option) {
      return option;
    } : _ref$filterOptions,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useFormContext = (0, _CustomForm.useFormContext)(),
    displayError = _useFormContext.displayError;
  var loadOptions = function loadOptions(inputValue, callback) {
    return callApi(inputValue, callback);
  };
  var callApi = (0, _react.useCallback)(_lodash["default"].debounce(function (inputValue, callback) {
    _Http["default"].get(getUrl(inputValue)).then(function (options) {
      return callback(options.filter(filterOptions).map(format));
    });
  }, 500), [filterOptions, format]);
  var style = (0, _react.useMemo)(function () {
    return getComputedStyle(document.body);
  }, []);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "custom-form-field"
  }, label != '' && /*#__PURE__*/_react["default"].createElement("label", null, label), /*#__PURE__*/_react["default"].createElement(_async["default"], _extends({
    value: value,
    onChange: function onChange(val) {
      return _onChange(multi ? val.map(function (v) {
        return v.value;
      }) : val);
    },
    loadOptions: loadOptions,
    noOptionsMessage: function noOptionsMessage(_ref2) {
      var inputValue = _ref2.inputValue;
      return _noOptionsMessage(inputValue);
    },
    placeholder: placeholder,
    isDisabled: disabled
  }, (0, _reactSelectStyle.reactSelectStyle)(displayError, isValid), props)));
};
var _default = exports["default"] = CustomFormFieldAsyncSelect;