"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _CustomFormField = _interopRequireDefault(require("./CustomFormField"));
var _excluded = ["options", "onChange", "value"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var CustomFormFieldCheckboxes = function CustomFormFieldCheckboxes(_ref) {
  var options = _ref.options,
    onChange = _ref.onChange,
    value = _ref.value,
    props = _objectWithoutProperties(_ref, _excluded);
  var handleChange = function handleChange(optionValue, checked) {
    if (checked) {
      onChange([].concat(_toConsumableArray(value), [optionValue]));
    } else {
      var copy = _toConsumableArray(value);
      var index = copy.findIndex(function (v) {
        return v === optionValue;
      });
      copy.splice(index, 1);
      onChange(copy);
    }
  };
  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: "checkboxes inline"
  }, props), options.map(function (option, key) {
    return /*#__PURE__*/_react["default"].createElement(_CustomFormField["default"], {
      key: key,
      type: "checkbox",
      label: option.label,
      onChange: function onChange(checked) {
        return handleChange(option.value, checked);
      },
      value: value.includes(option.value),
      id: "".concat(option.label).concat(key)
    });
  }));
};
var _default = exports["default"] = CustomFormFieldCheckboxes;