"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _CustomFormField = _interopRequireDefault(require("./CustomFormField"));
var _SubTitle = _interopRequireDefault(require("./SubTitle"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
var ListFormControl = function ListFormControl(_ref) {
  var _ref$label = _ref.label,
    label = _ref$label === void 0 ? '' : _ref$label,
    _ref$list = _ref.list,
    list = _ref$list === void 0 ? [] : _ref$list,
    _ref$setList = _ref.setList,
    setList = _ref$setList === void 0 ? function () {} : _ref$setList,
    _ref$titleActions = _ref.titleActions,
    titleActions = _ref$titleActions === void 0 ? [] : _ref$titleActions,
    _ref$fields = _ref.fields,
    fields = _ref$fields === void 0 ? [] : _ref$fields,
    _ref$titleClass = _ref.titleClass,
    titleClass = _ref$titleClass === void 0 ? '' : _ref$titleClass,
    _ref$canSwitch = _ref.canSwitch,
    canSwitch = _ref$canSwitch === void 0 ? false : _ref$canSwitch;
  var remove = function remove(index) {
    var copy = _toConsumableArray(list);
    copy.splice(index, 1);
    setList(copy);
  };
  var update = function update(index, propName, value) {
    var copy = _toConsumableArray(list);
    copy[index][propName] = value;
    setList(copy);
  };
  var getFieldLabel = function getFieldLabel(field) {
    var label = field.label;
    return label != null ? label.charAt(0).toUpperCase() + label.slice(1) : label;
  };
  var isLast = function isLast(indexItem) {
    return indexItem === list.length - 1;
  };
  var switchItems = function switchItems(index) {
    var copy = _toConsumableArray(list);
    copy[index] = copy.splice(index + 1, 1, copy[index])[0];
    setList(copy);
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "list-form-control"
  }, /*#__PURE__*/_react["default"].createElement(_SubTitle["default"], {
    className: titleClass,
    actions: titleActions
  }, label), list.map(function (item, indexItem) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      key: indexItem
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "form-line align-end"
    }, fields.map(function (f, indexField) {
      var _f$options;
      return /*#__PURE__*/_react["default"].createElement(_CustomFormField["default"], {
        key: "".concat(indexField, "_").concat(indexItem),
        placeholder: f.placeholder,
        label: getFieldLabel(f),
        value: item[f.propName],
        onChange: function onChange(value) {
          return update(indexItem, f.propName, value);
        },
        type: f.type == null ? 'text' : f.type,
        isValid: !f.required || item[f.propName] != '',
        options: (_f$options = f.options) !== null && _f$options !== void 0 ? _f$options : []
      });
    }), /*#__PURE__*/_react["default"].createElement("button", {
      type: "button",
      className: "btn btn-danger delete-button",
      onClick: function onClick() {
        return remove(indexItem);
      }
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: "mdi mdi-delete mdi-36px"
    }))), canSwitch && !isLast(indexItem) && /*#__PURE__*/_react["default"].createElement("div", {
      className: "flex center niveau-switch-button-container"
    }, /*#__PURE__*/_react["default"].createElement("button", {
      className: "btn btn-primary",
      type: "button",
      onClick: function onClick(e) {
        return switchItems(indexItem);
      },
      title: "Echanger"
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: "mdi mdi-swap-vertical mdi-36px"
    }))));
  }));
};
var _default = exports["default"] = ListFormControl;