"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _lodash = _interopRequireDefault(require("lodash"));
var _react = _interopRequireWildcard(require("react"));
var _CustomFormField = _interopRequireDefault(require("../form/CustomFormField"));
var _useUpdateEffect = _interopRequireDefault(require("../hooks/useUpdateEffect"));
var _Pagination = _interopRequireDefault(require("./Pagination"));
var _TableSearch = _interopRequireDefault(require("./TableSearch"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var TablePaginatedSearch = function TablePaginatedSearch(_ref) {
  var paginatedItems = _ref.paginatedItems,
    _ref$setPaginatedItem = _ref.setPaginatedItems,
    setPaginatedItems = _ref$setPaginatedItem === void 0 ? function () {} : _ref$setPaginatedItem,
    _ref$fields = _ref.fields,
    fields = _ref$fields === void 0 ? [] : _ref$fields,
    _ref$editItem = _ref.editItem,
    editItem = _ref$editItem === void 0 ? null : _ref$editItem,
    _ref$deleteItem = _ref.deleteItem,
    deleteItem = _ref$deleteItem === void 0 ? null : _ref$deleteItem,
    _ref$actions = _ref.actions,
    actions = _ref$actions === void 0 ? [] : _ref$actions,
    _ref$hideSearch = _ref.hideSearch,
    hideSearch = _ref$hideSearch === void 0 ? false : _ref$hideSearch,
    _ref$rowTemplate = _ref.rowTemplate,
    rowTemplate = _ref$rowTemplate === void 0 ? null : _ref$rowTemplate,
    _ref$initSearch = _ref.initSearch,
    initSearch = _ref$initSearch === void 0 ? '' : _ref$initSearch;
  var _useState = (0, _react.useState)(initSearch),
    _useState2 = _slicedToArray(_useState, 2),
    search = _useState2[0],
    setSearch = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = _slicedToArray(_useState3, 2),
    isLoading = _useState4[0],
    setIsLoading = _useState4[1];
  (0, _useUpdateEffect["default"])(function () {
    searchItems(search);
  }, [search]);
  var fetchItems = (0, _react.useCallback)(function (search) {
    var page = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
    setIsLoading(true);
    Promise.resolve(setPaginatedItems(search, page)).then(function () {
      return setIsLoading(false);
    });
  }, []);
  var searchItems = (0, _react.useCallback)(_lodash["default"].debounce(function (search) {
    return fetchItems(search);
  }, 500), []);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, paginatedItems != null && /*#__PURE__*/_react["default"].createElement("div", {
    className: "table-paginated-search"
  }, !hideSearch && /*#__PURE__*/_react["default"].createElement(_CustomFormField["default"], {
    label: "Rechercher",
    value: search,
    onChange: function onChange(value) {
      return setSearch(value);
    }
  }), !isLoading ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_TableSearch["default"], {
    items: paginatedItems.items,
    fields: fields,
    editItem: editItem,
    deleteItem: deleteItem,
    hideSearch: true,
    actions: actions,
    rowTemplate: rowTemplate
  }), /*#__PURE__*/_react["default"].createElement(_Pagination["default"], {
    pagination: paginatedItems,
    fetch: function fetch(page) {
      return fetchItems(search, page);
    }
  })) : /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex center"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "spinner-border text-primary",
    role: "status"
  }))));
};
var _default = exports["default"] = TablePaginatedSearch;