"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _form = require("../form");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var TableSearch = function TableSearch(_ref) {
  var _ref$items = _ref.items,
    items = _ref$items === void 0 ? [] : _ref$items,
    _ref$fields = _ref.fields,
    fields = _ref$fields === void 0 ? [] : _ref$fields,
    _ref$filter = _ref.filter,
    filter = _ref$filter === void 0 ? function (item, search) {
      return true;
    } : _ref$filter,
    _ref$editItem = _ref.editItem,
    editItem = _ref$editItem === void 0 ? null : _ref$editItem,
    _ref$deleteItem = _ref.deleteItem,
    deleteItem = _ref$deleteItem === void 0 ? null : _ref$deleteItem,
    _ref$actions = _ref.actions,
    actions = _ref$actions === void 0 ? [] : _ref$actions,
    _ref$hideSearch = _ref.hideSearch,
    hideSearch = _ref$hideSearch === void 0 ? false : _ref$hideSearch,
    _ref$rowTemplate = _ref.rowTemplate,
    rowTemplate = _ref$rowTemplate === void 0 ? null : _ref$rowTemplate,
    _ref$isLoading = _ref.isLoading,
    isLoading = _ref$isLoading === void 0 ? false : _ref$isLoading,
    _ref$initSearch = _ref.initSearch,
    initSearch = _ref$initSearch === void 0 ? '' : _ref$initSearch;
  var _useState = (0, _react.useState)(initSearch),
    _useState2 = _slicedToArray(_useState, 2),
    search = _useState2[0],
    setSearch = _useState2[1];
  var allActions = (0, _react.useMemo)(function () {
    var actionsCopy = _toConsumableArray(actions);
    if (editItem != null) {
      actionsCopy.push(function (item) {
        return /*#__PURE__*/_react["default"].createElement("span", {
          className: "mdi mdi-pencil mdi-24px clickable text-primary",
          onClick: function onClick() {
            return editItem(item);
          }
        });
      });
    }
    if (deleteItem != null) {
      actionsCopy.push(function (item) {
        return /*#__PURE__*/_react["default"].createElement("span", {
          className: "mdi mdi-delete mdi-24px clickable text-danger",
          onClick: function onClick() {
            return deleteItem(item);
          }
        });
      });
    }
    return actionsCopy;
  }, [actions, editItem, deleteItem]);
  var filteredItems = (0, _react.useMemo)(function () {
    return items.filter(function (item) {
      return filter(item, search);
    });
  }, [items, search]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "table-search"
  }, !hideSearch && /*#__PURE__*/_react["default"].createElement(_form.CustomFormField, {
    label: "Rechercher",
    value: search,
    onChange: function onChange(value) {
      return setSearch(value);
    }
  }), /*#__PURE__*/_react["default"].createElement("table", {
    className: "table"
  }, /*#__PURE__*/_react["default"].createElement("thead", null, /*#__PURE__*/_react["default"].createElement("tr", null, fields.map(function (field, index) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      key: index
    }, /*#__PURE__*/_react["default"].createElement("th", null, field.label));
  }), allActions.length > 0 && /*#__PURE__*/_react["default"].createElement("th", null))), /*#__PURE__*/_react["default"].createElement("tbody", null, isLoading ? /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", {
    colSpan: fields.length + 1
  }, /*#__PURE__*/_react["default"].createElement("div", {
    div: true,
    className: "flex center"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "spinner-border",
    role: "status"
  })))) : filteredItems.map(function (item, i) {
    return rowTemplate != null ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      key: i
    }, rowTemplate(item)) : /*#__PURE__*/_react["default"].createElement("tr", {
      key: i
    }, fields.map(function (field, j) {
      return /*#__PURE__*/_react["default"].createElement("td", {
        key: j
      }, field.get(item));
    }), /*#__PURE__*/_react["default"].createElement("td", null, /*#__PURE__*/_react["default"].createElement("div", {
      className: "flex end spaced-inline"
    }, allActions.map(function (action, index) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
        key: index
      }, action(item));
    }))));
  }))));
};
var _default = exports["default"] = TableSearch;