"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _axios = _interopRequireDefault(require("axios"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
// import TokenManager from "./TokenManager"

// const completeServerURL = `${process.env.API_URL}/api`

var queryStringBuild = function queryStringBuild(url) {
  var isAPIRequest = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var resURL = url;
  if (!url.includes('http://') && !url.includes('https://')) {
    resURL = "".concat(isAPIRequest ? '/api' : '').concat(url);
  }
  return resURL;
};
var setHeaders = function setHeaders() {
  var headers = {};
  if (window.USER_API_KEY != null) headers['X-AUTH-TOKEN'] = window.USER_API_KEY;
  return headers;
};

// const checkHttpError = res => {
//     if (!res.ok) {
//         if (res.status === 401 && res.statusText === 'Unauthorized') {
//             TokenManager.removeToken()
//         }
//         throw `${res.status} ${res.statusText}`
//     }
//     return res
// }

var checkError = function checkError(res) {
  if (res != null) {
    if (res['@type'] === 'hydra:Error') {
      throw res['hydra:description'];
    }
  }
  return res;
};
var Http = /*#__PURE__*/_createClass(function Http() {
  _classCallCheck(this, Http);
});
_defineProperty(Http, "get", function (url) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var isAPIRequest = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  return _axios["default"].get(queryStringBuild(url, isAPIRequest), _objectSpread({
    params: params,
    headers: setHeaders()
  }, options)).then(function (response) {
    return response.data;
  });
});
_defineProperty(Http, "post", function (url, body) {
  var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var isAPIRequest = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  return _axios["default"].post(queryStringBuild(url, isAPIRequest), JSON.stringify(body), {
    params: params,
    headers: setHeaders()
  }).then(function (response) {
    return response.data;
  });
});
_defineProperty(Http, "delete", function (url) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var isAPIRequest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  return _axios["default"]["delete"](queryStringBuild(url, isAPIRequest), {
    headers: setHeaders(),
    params: params
  }).then(function (response) {
    return response.data;
  });
});
_defineProperty(Http, "put", function (url, body) {
  var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var isAPIRequest = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  return _axios["default"].put(queryStringBuild(url, isAPIRequest), JSON.stringify(body), {
    params: params,
    headers: _objectSpread({
      'Content-Type': 'application/merge-patch+json'
    }, setHeaders())
  }).then(function (response) {
    return response.data;
  });
});
_defineProperty(Http, "patch", function (url, body) {
  var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var isAPIRequest = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  return _axios["default"].patch(queryStringBuild(url, isAPIRequest), JSON.stringify(body), {
    params: params,
    headers: _objectSpread({
      'Content-Type': 'application/merge-patch+json'
    }, setHeaders())
  }).then(function (response) {
    return response.data;
  });
});
_defineProperty(Http, "postFormData", function (url, formData) {
  var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var isAPIRequest = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  return _axios["default"].post(queryStringBuild(url, isAPIRequest), formData, {
    params: params,
    headers: setHeaders()
  }).then(function (response) {
    return response.data;
  });
});
var _default = exports["default"] = Http;